src/Entity/Voiture.php
<?php

namespace App\Entity;

use App\Repository\VoitureRepository;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Serializer\Annotation\Groups;

/**
 * @ORM\Entity(repositoryClass=VoitureRepository::class)
 */
class Voiture
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     * @Groups("getVoiture")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Groups("getVoiture")
     */
    private $matricule;

    /**
     * @ORM\Column(type="string", length=255)
     * @Groups("getVoiture")
     */
    private $carburan_type;

    /**
     * @ORM\Column(type="string", length=255)
     * @Groups("getVoiture")
     */
    private $cheveaux;

    /**
     * @ORM\Column(type="string", length=255)
     * @Groups("getVoiture")
     */
    private $adresse;

    /**
     * @ORM\Column(type="string", length=255)
     * @Groups("getVoiture")
     */
    private $prix;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getMatricule(): ?string
    {
        return $this->matricule;
    }

    public function setMatricule(string $matricule): self
    {
        $this->matricule = $matricule;

        return $this;
    }

    public function getCarburanType(): ?string
    {
        return $this->carburan_type;
    }

    public function setCarburanType(string $carburan_type): self
    {
        $this->carburan_type = $carburan_type;

        return $this;
    }

    public function getCheveaux(): ?string
    {
        return $this->cheveaux;
    }

    public function setCheveaux(string $cheveaux): self
    {
        $this->cheveaux = $cheveaux;

        return $this;
    }

    public function getAdresse(): ?string
    {
        return $this->adresse;
    }

    public function setAdresse(string $adresse): self
    {
        $this->adresse = $adresse;

        return $this;
    }

    public function getPrix(): ?string
    {
        return $this->prix;
    }

    public function setPrix(string $prix): self
    {
        $this->prix = $prix;

        return $this;
    }

}

src/Form/VoitureType.php
<?php

namespace App\Form;

use App\Entity\Voiture;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class VoitureType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('matricule')
            ->add('carburan_type')
            ->add('cheveaux')
            ->add('adresse')
            ->add('prix')
            ->add('cle_carrosserie')
            ->add('cle_interieur')
            ->add('cle_niveau')
            ->add('cle_mecanique')
            ->add('cle_vitre')
            ->add('cle_papier')
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Voiture::class,
        ]);
    }
}

src/Controller/VoitureController.php
<?php

namespace App\Controller;

use App\Entity\Voiture;
use App\Form\VoitureType;
use App\Repository\VoitureRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Validator\Validator\ValidatorInterface;
use Symfony\Component\HttpFoundation\JsonResponse;

/**
 * @Route("/voiture")
 */
class VoitureController extends AbstractController
{
    /**
     * @Route("/", name="voiture_index", methods={"GET"})
     */
    public function index(VoitureRepository $voitureRepository): Response
    {
        $voiture = $voitureRepository->findAll();
        return $this->json($voiture);
    }

    /**
     * @Route("/new", name="voiture_new", methods={"POST"})
     */
    public function new(Request $request, ValidatorInterface $validator): Response
    {

        $datas = $request->toArray();

        $matriculeReceived = $datas['matricule'];
        $carburanTypeReceived = $datas['carburan_type'];
        $cheveauxReceived = $datas['cheveaux'];
        $adresseReceived = $datas['adresse'];
        $prixReceived = $datas['prix'];

        $entityManager = $this->getDoctrine()->getManager();

        $voitureRepository = new Voiture();
        $voitureRepository->setMatricule($matriculeReceived);
        $voitureRepository->setCarburanType($carburanTypeReceived);
        $voitureRepository->setCheveaux($cheveauxReceived);
        $voitureRepository->setAdresse($adresseReceived);
        $voitureRepository->setPrix($prixReceived);

        $errors = $validator->validate($voitureRepository);
        if (count($errors) > 0) {
            $errorsString = (string) $errors;
            return new Response($errorsString);
        }
        
        $entityManager->persist($voitureRepository);
        $entityManager->flush();
        
        $voiture=$voitureRepository->getId();

        return new JsonResponse(
            [
                'id'    => $voiture,
                '$matriculeReceived' => $matriculeReceived,
                '$carburanTypeReceived' => $carburanTypeReceived,
                '$cheveauxReceived' => $cheveauxReceived,
                '$adresseReceived' => $adresseReceived,
                '$prixReceived' => $prixReceived,


            ]
        );
    }

    /**
     * @Route("/{id}", name="voiture_show", methods={"GET"})
     */
    public function show(Voiture $voiture): Response
    {
        return $this->json(['voiture' => $voiture]);
    }

    /**
     * @Route("/{id}/edit", name="voiture_edit", methods={"POST"})
     */
    public function edit(Request $request, Voiture $voiture, ValidatorInterface $validator): Response
    {

        $datas = $request->toArray();

        $matriculeReceived = $datas['matricule'];
        $carburanTypeReceived = $datas['carburan_type'];
        $cheveauxReceived = $datas['cheveaux'];
        $adresseReceived = $datas['adresse'];
        $prixReceived = $datas['prix'];

        $entityManager = $this->getDoctrine()->getManager();

        // $carrosserie = new Carrosserie();

        $voiture->setMatricule($matriculeReceived);
        $voiture->setCarburanType($carburanTypeReceived);
        $voiture->setCheveaux($cheveauxReceived);
        $voiture->setAdresse($adresseReceived);
        $voiture->setPrix($prixReceived);

        $errors = $validator->validate($voiture);
        if (count($errors) > 0) {

            $errorsString = (string) $errors;

            return new Response($errorsString);
        }

        $entityManager->persist($voiture);
        $entityManager->flush();

        $voiture=$voiture->getId();

        return $this->json(
            [
                'status'    => 'Edit / Modif Voiture confirmé !',

                'id'    => $voiture,
                '$matriculeReceived' => $matriculeReceived,
                '$carburanTypeReceived' => $carburanTypeReceived,
                '$cheveauxReceived' => $cheveauxReceived,
                '$adresseReceived' => $adresseReceived,
                '$prixReceived' => $prixReceived,
            ]
        );
    }

    /**
     * @Route("/{id}/delete", name="voiture_delete", methods={"POST"})
     */
    public function delete(Request $request, Voiture $voiture): Response
    {
        if ($this->isCsrfTokenValid('delete'.$voiture->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($voiture);
            $entityManager->flush();
        }

        return new JsonResponse(
            [
                'status'    => 'Delete Voiture confirmé !',
            ]
        );
    }
}

templates/voiture/_delete_form.html.twig
<form method="post" action="{{ path('voiture_delete', {'id': voiture.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ voiture.id) }}">
    <button class="btn">Delete</button>
</form>

templates/voiture/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/voiture/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Voiture{% endblock %}

{% block body %}
    <h1>Edit Voiture</h1>

    {{ include('voiture/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('voiture_index') }}">back to list</a>

    {{ include('voiture/_delete_form.html.twig') }}
{% endblock %}

templates/voiture/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Voiture index{% endblock %}

{% block body %}
    <h1>Voiture index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Matricule</th>
                <th>Carburan_type</th>
                <th>Cheveaux</th>
                <th>Adresse</th>
                <th>Prix</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for voiture in voitures %}
            <tr>
                <td>{{ voiture.id }}</td>
                <td>{{ voiture.matricule }}</td>
                <td>{{ voiture.carburanType }}</td>
                <td>{{ voiture.cheveaux }}</td>
                <td>{{ voiture.adresse }}</td>
                <td>{{ voiture.prix }}</td>
                <td>
                    <a href="{{ path('voiture_show', {'id': voiture.id}) }}">show</a>
                    <a href="{{ path('voiture_edit', {'id': voiture.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="7">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('voiture_new') }}">Create new</a>
{% endblock %}

templates/voiture/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Voiture{% endblock %}

{% block body %}
    <h1>Create new Voiture</h1>

    {{ include('voiture/_form.html.twig') }}

    <a href="{{ path('voiture_index') }}">back to list</a>
{% endblock %}

templates/voiture/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Voiture{% endblock %}

{% block body %}
    <h1>Voiture</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ voiture.id }}</td>
            </tr>
            <tr>
                <th>Matricule</th>
                <td>{{ voiture.matricule }}</td>
            </tr>
            <tr>
                <th>Carburan_type</th>
                <td>{{ voiture.carburanType }}</td>
            </tr>
            <tr>
                <th>Cheveaux</th>
                <td>{{ voiture.cheveaux }}</td>
            </tr>
            <tr>
                <th>Adresse</th>
                <td>{{ voiture.adresse }}</td>
            </tr>
            <tr>
                <th>Prix</th>
                <td>{{ voiture.prix }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('voiture_index') }}">back to list</a>

    <a href="{{ path('voiture_edit', {'id': voiture.id}) }}">edit</a>

    {{ include('voiture/_delete_form.html.twig') }}
{% endblock %}